/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 GPIỌ
 PA0

*/

#include "debug.h"

/* Global define */

/* Global Variable */

/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0
 *
 * @return  none
 */
void on_Protect(void)
{
    if(FLASH_GetReadOutProtectionStatus()!=SET)
    {
        FLASH_Unlock();
        FLASH_ReadOutProtection(ENABLE);
        FLASH_Lock();
    }
}
void off_Protect(void)
{
    if(FLASH_GetReadOutProtectionStatus()!=RESET)
    {
        FLASH_Unlock();
        FLASH_ReadOutProtection(DISABLE);
        FLASH_Lock();
    }
}
void GPIO_Toggle_INIT(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}
void key_Toggle_INIT(void)
{
    GPIO_InitTypeDef KEY = {0};
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    KEY.GPIO_Pin = GPIO_Pin_1;
    KEY.GPIO_Mode = GPIO_Mode_IPU;
    KEY.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &KEY);
}
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    on_Protect();
    u8 i = 0;
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);

    printf("GPIO Toggle TEST\r\n");
    GPIO_Toggle_INIT();
    key_Toggle_INIT();
    printf("%x\r\n",FLASH->OBR);
    while(1)
    {
        if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)==0)
        {
            Delay_Ms(50);
            off_Protect();
        }
        else
        printf("%x\r\n",FLASH->OBR);
        Delay_Ms(250);
        GPIO_WriteBit(GPIOA, GPIO_Pin_0, (i == 0) ? (i = Bit_SET) : (i = Bit_RESET));
    }
}
